## tulip 4.4.0dfsg2

=== CMakeLists.txt ===
PROJECT(tulip)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.3)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR})

## ========================================================
## Build type detection
## ========================================================

IF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE TRUE)
ELSE(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE FALSE)
ENDIF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")

## ========================================================
## Check processor architecture
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_SIZEOF_VOID_P}" "8" I64)
IF(I64)
  SET(PROCESSOR_ARCHITECTURE "64")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DI64")
ELSE(I64)
  SET(PROCESSOR_ARCHITECTURE "32")
ENDIF(I64)

## ========================================================
## Consider FreeBSD as Linux
## ========================================================
EXEC_PROGRAM(uname OUTPUT_VARIABLE UNAME_OUT)
STRING(COMPARE EQUAL "${UNAME_OUT}" "Linux" LINUX)
IF(NOT LINUX)
  STRING(COMPARE EQUAL "${UNAME_OUT}" "GNU/kFreeBSD" LINUX)
ENDIF(NOT LINUX)

## ========================================================
## Operating system preprocessor macros
## ========================================================
IF(LINUX)
  ADD_DEFINITIONS("-D_LINUX")
ENDIF(LINUX)
IF(WIN32)
  ADD_DEFINITIONS("-D_WIN32")
ENDIF(WIN32)
IF(APPLE)
  ADD_DEFINITIONS("-D__APPLE__")
ENDIF(APPLE)

## ========================================================
## Tulip version variables
## ========================================================
SET(TulipMajorVersion 4)
SET(TulipMinorVersion 4)
SET(TulipReleaseVersion 0)
SET(TulipVersionSeparator .)
IF(MSVC) #specific options for Visual Studio
  SET(TulipVersionSeparator _)
ENDIF()
SET(TulipVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}${TulipVersionSeparator}${TulipReleaseVersion}")
SET(TulipMMVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}")
SET(TulipIntVersion "${TulipMajorVersion}${TulipMinorVersion}${TulipReleaseVersion}")

## ========================================================
## Tulip libraries names
## ========================================================
SET(LibTulipCoreName "tulip-core-${TulipMMVersion}")
SET(LibTulipOglName "tulip-ogl-${TulipMMVersion}")
SET(LibTulipGUIName "tulip-gui-${TulipMMVersion}")
SET(LibTulipPythonName "tulip-python-${TulipMMVersion}")
SET(LibTulipOGDFName "tulip-ogdf-${TulipMMVersion}")
SET(LibStlPythonBindingsName "stl-python-bindings")
SET(LibTulipCorePythonBindingsName "tulip-core-python-bindings")
SET(LibTulipOGLPythonBindingsName "tulip-opengl-python-bindings")
SET(LibTulipGUIPythonBindingsName "tulip-gui-python-bindings")
SET(TulipLibs ${LibTulipCoreName} ${LibTulipOglName} ${LibTulipGUIName} ${LibTulipOGDFName})

## ========================================================
## Current year (used in documentation config files)
## ========================================================
IF (WIN32)
  EXECUTE_PROCESS(COMMAND "echo" "%DATE:~6,4%" OUTPUT_VARIABLE CurrentYear OUTPUT_STRIP_TRAILING_WHITESPACE)
ELSEIF(UNIX)
  EXECUTE_PROCESS(COMMAND "date" "+%Y" OUTPUT_VARIABLE CurrentYear OUTPUT_STRIP_TRAILING_WHITESPACE)
ENDIF()

## ========================================================
## Configure file for uninstall target
## ========================================================
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake VERBATIM)

## ========================================================
## Additional macros
## ========================================================
INCLUDE(TulipUseFile.cmake)

## ========================================================
## Point RPATH to lib folder
## ========================================================
FUNCTION(ADD_LIBRARY name)
  _ADD_LIBRARY(${name} ${ARGN})
  IF(APPLE)
    SET_TARGET_PROPERTIES(${name} PROPERTIES INSTALL_NAME_DIR "@executable_path/../lib")
  ENDIF(APPLE)
  SET_TARGET_PROPERTIES(${name} PROPERTIES INSTALL_RPATH "$ORIGIN")
ENDFUNCTION()
FUNCTION(ADD_EXECUTABLE name)
  _ADD_EXECUTABLE(${name} ${ARGN})
  IF(APPLE)
    SET_TARGET_PROPERTIES(${name} PROPERTIES INSTALL_NAME_DIR "@executable_path/../lib")
  ENDIF(APPLE)
  IF(LINUX OR APPLE)
    SET_TARGET_PROPERTIES(${name} PROPERTIES INSTALL_RPATH "$ORIGIN/../lib")
  ELSE(LINUX OR APPLE)
    SET_TARGET_PROPERTIES(${name} PROPERTIES INSTALL_RPATH "$ORIGIN")
  ENDIF(LINUX OR APPLE)
ENDFUNCTION()

## ========================================================
## Compiler-specific options
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_CXX_COMPILER_ID}" "Clang" CLANG)

SET_COMPILER_OPTIONS()

IF(BUILD_TESTS)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  INCLUDE(CTest)
ENDIF()

## ========================================================
## Required packages
## ========================================================

# Qt
FIND_PACKAGE(QtX)

# Freetype
FIND_PACKAGE(Freetype REQUIRED)

# ZLIB
FIND_PACKAGE(ZLIB REQUIRED)

# Yajl
SET(YAJL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/yajl/src ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/yajl/src/api ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/yajl/src/yajl ${CMAKE_CURRENT_BUILD_DIR}/thirdparty/yajl/yajl-2.0.1/include)

# OpenGL
FIND_PACKAGE(OpenGL REQUIRED)

# Glew
FIND_PACKAGE(GLEW REQUIRED)

# OpenMP
IF(NOT CLANG)
FIND_PACKAGE(Threads)
OPTION(ENABLE_OPENMP "Do you want to enable OpenMP?" ON)
IF(ENABLE_OPENMP)
    FIND_PACKAGE(OpenMP)
    IF(OPENMP_FOUND)
        SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_CXX_FLAGS}")
        SET(OPENMP_CXX_FLAGS "${OpenMP_CXX_FLAGS}")
        IF(WIN32)
            IF(MSVC)
                SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /openmp")
                SET(OPENMP_CXX_FLAGS "/openmp")
            ELSE()
                SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp ${CMAKE_THREAD_LIBS_INIT}")
                SET(OPENMP_LIBRARIES "-lgomp -lpthread")
            ENDIF()
        ENDIF()
    ELSE(OPENMP_FOUND)
        IF(WIN32)
            STRING(COMPARE NOTEQUAL "${OpenMP_C_FLAGS}" "" OMP_CFLAGS)
            IF(OMP_CFLAGS)
                # Force setting OpenMP flags on Windows plateforms
                SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_C_FLAGS}")
                SET(OPENMP_CXX_FLAGS "${OpenMP_C_FLAGS}")
                IF(NOT MSVC)
                    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
                    SET(OPENMP_LINKER_FLAGS "${OpenMP_C_FLAGS}")
                    SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp -lpthread")
                    SET(OPENMP_LIBRARIES "-lgomp -lpthread")
                ENDIF(NOT MSVC)
                SET(OPENMP_FOUND TRUE)
            ELSE(OMP_CFLAGS)
                MESSAGE("OpenMP not found: multithreaded code will not be used")
            ENDIF(OMP_CFLAGS)
        ELSE(WIN32)
            MESSAGE("OpenMP not found: multithreaded code will not be used")
        ENDIF(WIN32)
        ## ========================================================
        ## Enable debugging of OpenMP
        ## ========================================================
        IF(CMAKE_DEBUG_MODE AND NOT CHECK_MEMORY)
            SET(DEBUG_OPENMP OFF CACHE BOOL "Do you want to enable OpenMP even in Debug mode ? [OFF|ON]")
            IF(DEBUG_OPENMP)
                SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${OPENMP_CXX_FLAGS}")
                SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OPENMP_LINKER_FLAGS}")
                SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} ${OPENMP_LIBRARIES}")
            ENDIF(DEBUG_OPENMP)
        ENDIF(CMAKE_DEBUG_MODE AND NOT CHECK_MEMORY)
    ENDIF(OPENMP_FOUND)
ENDIF(ENABLE_OPENMP)
ENDIF(NOT CLANG)

# Python
# After finding the Python interpreter, try to find if SIP and its dev tools are installed on the host system.
# If not, compile the SIP version located in thirdparty.
FIND_PACKAGE(PythonInterp REQUIRED)
IF(PYTHONINTERP_FOUND)
  EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} --version ERROR_VARIABLE PYTHON_VERSION_RAW)
  STRING(REPLACE "\n" "" PYTHON_VERSION_RAW "${PYTHON_VERSION_RAW}")
  STRING(REGEX MATCH "[0-9]\\.[0-9]" PYTHON_VERSION "${PYTHON_VERSION_RAW}")
  STRING(REGEX MATCH "[0-9]\\.[0-9]\\.[0-9]" PYTHON_VERSION_WITH_PATCH "${PYTHON_VERSION_RAW}")

  # Find the Python library with the same version as the interpreter
  # Starting Python 3.2, the library is suffixed by mu, also handle that case
  SET(Python_ADDITIONAL_VERSIONS ${PYTHON_VERSION}mu ${PYTHON_VERSION})
  FIND_PACKAGE(PythonLibs REQUIRED)

  IF(PYTHONLIBS_FOUND)
    SET(SIP_OK FALSE CACHE INTERNAL "")
    FIND_PACKAGE(SIP)
    SET(SIP_OK ${SIP_FOUND})
    IF(SIP_OK)
      SET(SIP_EXE "${SIP_EXECUTABLE}")
      SET(SYSTEM_SIP TRUE)
    ELSE(SIP_OK)
      SET(SIP_LIB sip)
      SET(SYSTEM_SIP FALSE)
      TRY_COMPILE(SIP_OK ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.14/sipgen ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/sip-4.14/sipgen sip CMAKE_FLAGS -DCMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES})
      IF(SIP_OK)
        SET(SIP_VERSION_STR "4.14")
        IF(WIN32 AND EXISTS "${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.14/sipgen/Debug/sip.exe")
          SET(SIP_EXE ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.14/sipgen/Debug/sip.exe)
        ELSE()
          SET(SIP_EXE ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.14/sipgen/sip)
        ENDIF()
        SET(SIP_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/sip-4.14/siplib/)
      ENDIF(SIP_OK)
    ENDIF(SIP_OK)
    SET(Sphinx_DIR ${CMAKE_CURRENT_SOURCE_DIR}/doc/python)
    MARK_AS_ADVANCED(Sphinx_DIR)
    FIND_PACKAGE(Sphinx)
  ENDIF(PYTHONLIBS_FOUND)
ENDIF(PYTHONINTERP_FOUND)


## ========================================================
## Include paths
## ========================================================
SET(GZStreamInclude ${PROJECT_SOURCE_DIR}/thirdparty/gzstream/)
SET(QuazipInclude ${PROJECT_SOURCE_DIR}/thirdparty/quazip)
SET(QxtInclude ${PROJECT_SOURCE_DIR}/thirdparty/qxt/src)
SET(FTGLInclude ${PROJECT_SOURCE_DIR}/thirdparty/ftgl/)
SET(qscintilla2Include ${PROJECT_SOURCE_DIR}/thirdparty/QScintilla-gpl-2.5.1/Qt4/)
SET(OGDFInclude ${PROJECT_SOURCE_DIR}/thirdparty/OGDF)
SET(OGDFLibrary OGDF)
SET(QHULLInclude ${PROJECT_SOURCE_DIR}/thirdparty)
SET(TulipCoreInclude ${PROJECT_SOURCE_DIR}/library/tulip-core/include/)
SET(TulipCoreBuildInclude ${PROJECT_BINARY_DIR}/library/tulip-core/include/)
SET(TulipOGLInclude ${PROJECT_SOURCE_DIR}/library/tulip-ogl/include/)
SET(TulipOGDFInclude ${PROJECT_SOURCE_DIR}/library/tulip-ogdf/)
SET(TulipGUIInclude ${PROJECT_SOURCE_DIR}/library/tulip-gui/include/)
SET(TulipGUIBuildInclude ${PROJECT_BINARY_DIR}/library/tulip-gui/include/)
SET(TulipPythonInclude ${PROJECT_SOURCE_DIR}/library/tulip-python/include)

## ========================================================
## Install paths
## ========================================================
SET(TulipLibInstallDir lib/)
SET(TulipPluginsInstallDir ${TulipLibInstallDir}/tulip/)
SET(TulipGlyphPluginsInstallDir ${TulipPluginsInstallDir}/glyph/)
SET(TulipViewPluginsInstallDir ${TulipPluginsInstallDir}/view/)
SET(TulipInteractorPluginsInstallDir ${TulipPluginsInstallDir}/interactor/)

=== doc/CMakeLists.txt ===
SET(BUILD_DOC ON CACHE BOOL "Do you want to build the documentation ? [ON|OFF]")
#Only
IF(BUILD_DOC)
  IF(PYTHONINTERP_FOUND AND SIP_OK)
    IF(SPHINX_FOUND)
      ADD_SUBDIRECTORY(python)
      ADD_SUBDIRECTORY(user)
      ADD_SUBDIRECTORY(developer)
    ELSE(SPHINX_FOUND)
      MESSAGE("Sphinx not found: unable to generate the documentation.")
    ENDIF(SPHINX_FOUND)
  ENDIF(PYTHONINTERP_FOUND AND SIP_OK)
 
  IF(LINUX)
    FIND_PACKAGE(Doxygen)
    IF(DOXYGEN_FOUND)
## ========================================================
## Custom target for doxygen documentation
## ========================================================
ADD_CUSTOM_TARGET(doc
  ${CMAKE_COMMAND} -E remove_directory ${CMAKE_SOURCE_DIR}/doc/html
  COMMAND doxygen tulip.Doxyfile
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/doc/doxygen/style/navtree.css ${CMAKE_SOURCE_DIR}/doc/html
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} VERBATIM)
    ENDIF(DOXYGEN_FOUND)
  ENDIF(LINUX)
ENDIF(BUILD_DOC)

=== externalplugins/CMakeLists.txt ===
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

#Automatic subdirectory search for CMakeLists.txt
FILE(GLOB CM_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*/CMakeLists.txt)

SET(EXTERNALPLUGINS TRUE)

FOREACH(CM_FILE ${CM_FILES})
STRING(REGEX REPLACE "//CMakeLists.txt" "" CM_SUBDIR ${CM_FILE})
ADD_SUBDIRECTORY(${CM_SUBDIR})
ENDFOREACH(CM_FILE)

=== library/CMakeLists.txt ===
ADD_SUBDIRECTORY(tulip-core)
ADD_SUBDIRECTORY(tulip-ogl)
ADD_SUBDIRECTORY(tulip-gui)
ADD_SUBDIRECTORY(tulip-ogdf)
ADD_SUBDIRECTORY(tulip-python)

=== plugins/CMakeLists.txt ===
IF(CHECK_MEMORY)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CHECK_MEMORY_FLAGS}")
ENDIF(CHECK_MEMORY)

ADD_SUBDIRECTORY(clustering)
ADD_SUBDIRECTORY(colors)
ADD_SUBDIRECTORY(import)
ADD_SUBDIRECTORY(layout)
ADD_SUBDIRECTORY(metric)
ADD_SUBDIRECTORY(selection)
ADD_SUBDIRECTORY(sizes)
ADD_SUBDIRECTORY(export)
ADD_SUBDIRECTORY(glyph)
ADD_SUBDIRECTORY(interactor)
ADD_SUBDIRECTORY(perspective)
ADD_SUBDIRECTORY(string)
ADD_SUBDIRECTORY(view)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(general)

=== software/CMakeLists.txt ===
IF(CHECK_MEMORY)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CHECK_MEMORY_FLAGS}")
ENDIF(CHECK_MEMORY)

ADD_SUBDIRECTORY(bitmaps)
ADD_SUBDIRECTORY(crash_handling)
ADD_SUBDIRECTORY(tulip)
ADD_SUBDIRECTORY(tulip_perspective)
ADD_SUBDIRECTORY(plugin_server)
IF(APPLE)
ADD_SUBDIRECTORY(mac_launcher)
ENDIF(APPLE)

=== textures/CMakeLists.txt ===
INSTALL(FILES
  arrowSprite.png
  candiSprite.png
  edgeBlomSprite.png
  edgeSpring.png
  titlebarGradient.png
  logo32x32.ico
  logolabri.jpg
DESTINATION ${TulipBitmapInstallDir}
COMPONENT tulip_textures
)

=== thirdparty/CMakeLists.txt ===
DISABLE_COMPILER_WARNINGS()

ADD_SUBDIRECTORY(gzstream)
ADD_SUBDIRECTORY(ftgl)
ADD_SUBDIRECTORY(OGDF)
ADD_SUBDIRECTORY(quazip)
ADD_SUBDIRECTORY(yajl)
ADD_SUBDIRECTORY(qxt)
ADD_SUBDIRECTORY(libqhull)

IF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
IF(SIP_OK AND NOT SIP_FOUND)
ADD_SUBDIRECTORY(sip-4.14)
ENDIF(SIP_OK AND NOT SIP_FOUND)
ENDIF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)

## -----------------------------------------------------------------------------------------------
## Install external libraries.
## Each external library is defined in its own component to ensure easy modifications of the CPack component dependency tree
## -----------------------------------------------------------------------------------------------

IF(WIN32)
## -----------------------------------------------------------------------------------------------
## Windows
## -----------------------------------------------------------------------------------------------

# Note: On Win32 systems, CMake variables doesn't provide the right libraries that have to be included in the bundle. (For instance, Qt variables redirect to .lib and not .dll)
#       We have to manually find those libs by invoking the FIND_LIBRARY_GLOB macro

# Base System
# Libs needed to provide sufficient runtime under Windows environments
  IF(MINGW)

    INSTALL_EXTERNAL_LIB("libgcc_s_*.dll" runtime)
    INSTALL_EXTERNAL_LIB("libstdc++-*.dll" runtime)
    INSTALL_EXTERNAL_LIB("*pthread*.dll" runtime)
    INSTALL_EXTERNAL_LIB("libgomp-*.dll" runtime)
    IF(GCXX_VERSION VERSION_LESS 4.8)
        INSTALL_EXTERNAL_LIB("mingwm*.dll" runtime)
        INSTALL_EXTERNAL_LIB("iconv.dll" iconv)
        INSTALL_EXTERNAL_LIB("libiconv-2.dll" iconv)
        INSTALL_EXTERNAL_LIB("libintl*.dll" intl)
    ENDIF(GCXX_VERSION VERSION_LESS 4.8)
  ENDIF(MINGW)
  
  INSTALL_EXTERNAL_LIB("*zlib*.dll" zlib)
  INSTALL_EXTERNAL_LIB("*glew*.dll" glew)
  INSTALL_EXTERNAL_LIB("*freetype*.dll" freetype)
  
  IF(USE_QT4)
	INSTALL_EXTERNAL_LIB("QtCore4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtGui4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtNetwork4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtOpenGL4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtXml4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtWebKit4.dll" qt)
	
	INSTALL_EXTERNAL_LIB("QtCored4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtGuid4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtNetworkd4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtOpenGLd4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtXmld4.dll" qt)
	INSTALL_EXTERNAL_LIB("QtWebKitd4.dll" qt)
	
	IF(QT_PHONON_LIBRARY)
		INSTALL_EXTERNAL_LIB("phonon4.dll" qt)
		INSTALL_EXTERNAL_LIB("phonond4.dll" qt)
	ENDIF(QT_PHONON_LIBRARY)

        IF(GCXX_VERSION VERSION_EQUAL 4.8.1)
            INSTALL_EXTERNAL_LIB("libpng*.dll" qt)
        ENDIF(GCXX_VERSION VERSION_EQUAL 4.8.1)
	
  ENDIF(USE_QT4)
  
  IF(USE_QT5)
	INSTALL_EXTERNAL_LIB("Qt5Core.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Gui.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Network.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5OpenGL.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Xml.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5WebKit.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5WebKitWidgets.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Widgets.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Multimedia.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5MultimediaWidgets.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5PrintSupport.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Sensors.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Sql.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Quick.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Qml.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5V8.dll" qt)
	
	INSTALL_EXTERNAL_LIB("Qt5Cored.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Guid.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Networkd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5OpenGLd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Xmld.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5WebKitd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5WebKitWidgetsd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Widgetsd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Multimediad.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5MultimediaWidgetsd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5PrintSupportd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Sensorsd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Sqld.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Quickd.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5Qmld.dll" qt)
	INSTALL_EXTERNAL_LIB("Qt5V8d.dll" qt)
	
        INSTALL_EXTERNAL_LIB("icuin*.dll" qt)
        INSTALL_EXTERNAL_LIB("icuuc*.dll" qt)
        INSTALL_EXTERNAL_LIB("icudt*.dll" qt)
  ENDIF(USE_QT5)
  
ENDIF(WIN32)

=== tlpscripten/CMakeLists.txt ===
## ========================================================
## Configure file for directories initialization
## ========================================================
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/init_dirs.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/init_dirs.sh" IMMEDIATE @ONLY)

## ========================================================
## copy scripts from src dir to bin dir
## ========================================================
FILE(GLOB SCRIPTS ${CMAKE_CURRENT_SOURCE_DIR}/*.sh)

ADD_CUSTOM_TARGET(copy_scripts)
FOREACH(script ${SCRIPTS})
  ADD_CUSTOM_COMMAND(TARGET copy_scripts PRE_BUILD
                     COMMAND ${CMAKE_COMMAND} -E
                     copy_if_different ${script} ${CMAKE_CURRENT_BINARY_DIR})
ENDFOREACH()

## ========================================================
## invoke main script
## ========================================================
ADD_CUSTOM_TARGET(tlpscripten sh tlpscripten.sh
                  DEPENDS copy_scripts)

=== unit_test/CMakeLists.txt ===
add_subdirectory(library)
if(LINUX)
add_subdirectory(plugins)
endif(LINUX)

=== demos/graph_display/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${TulipCoreBuildInclude} ${TulipCoreInclude} ${TulipOGLInclude} ${TulipGUIInclude})

IF(USE_QT5)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
ENDIF(USE_QT5)

ADD_EXECUTABLE(graph_display graph_display.cpp)
TARGET_LINK_LIBRARIES(graph_display ${TulipLibs} ${QT_LIBRARIES})

INSTALL(TARGETS graph_display DESTINATION demos)

=== doc/python/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_SOURCE_DIR}/conf.py)

ADD_CUSTOM_TARGET(pythonBindingsDoc ALL ${CMAKE_COMMAND} -DSPHINX_EXECUTABLE=${SPHINX_EXECUTABLE} -DSOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} -DBIN_DIR=${CMAKE_CURRENT_BINARY_DIR} -DSRC_DIR=${CMAKE_CURRENT_SOURCE_DIR} -DSYSTEM_SIP=${SYSTEM_SIP} -DQT_BIN_DIR=${QT_DOC_DIR}/../bin -DMSVC=${MSVC} -DAPPLE=${APPLE} -P ${CMAKE_CURRENT_SOURCE_DIR}/genSphinxDoc.cmake
                                  DEPENDS ${LibTulipCorePythonBindingsName} ${LibTulipOGLPythonBindingsName} ${LibTulipGUIPythonBindingsName} ${LibStlPythonBindingsName} VERBATIM)

SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "doc;doctrees") 

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html 
  DESTINATION ${TulipShareInstallDir}/doc/tulip-python
  COMPONENT tulip_python_doc)

=== debian/changelog ===
tulip (4.4.0dfsg2-2) unstable; urgency=medium

  * Activate #undef of minor() and major() in Plugin.h, which prevented
    build on kfreebsd.
  * Add removal of /usr/share/tulip/bitmaps/fonts in preinst, to properly
    handle its change from a dir to a symlink.

 -- Yann Dirson <dirson@debian.org>  Sat, 01 Feb 2014 21:51:05 +0100

tulip (4.4.0dfsg2-1) unstable; urgency=low

  * Repackage orig tarball without any trutype font (Closes: #735121),
    ship /usr/share/tulip/bitmaps/fonts as symlink to
    /usr/share/fonts/truetype use installed fonts instead.
  * Update debian/README.maint to show "git archive" use for dfsg.orig
    tarball generation.
  * Configure with -DBUILD_DOC=OFF to make sure doc files are not
    generated even with sphinx installed, as -doc package is not back yet.

 -- Yann Dirson <dirson@debian.org>  Thu, 16 Jan 2014 20:48:06 +0100

tulip (4.4.0dfsg-2) unstable; urgency=low

  * Add a default value for OS_ARCHITECTURE, since it is now used on all
    archs in the PluginManager (Closes: #734924).

 -- Yann Dirson <dirson@debian.org>  Sat, 11 Jan 2014 20:08:10 +0100

tulip (4.4.0dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #703041).
    * Builds again on current amd64 (Closes: #729738).
    * Includes manuals again (but needs python activated, and shpinx, to build)
    * Known to segfault on amd64 at startup, but uploading anyway since at least
      i386 does not have the bug.
  * Activate python support, build-depend on python-sip-dev; new
    libtulip-python* package.
  * Switch build-dep from libglew1.5-dev to libglew-dev.
  * Change dep from obsolete ttf-dejavu-core to fonts-dejavu-core.

 -- Yann Dirson <dirson@debian.org>  Sun, 05 Jan 2014 16:25:20 +0100

tulip (4.3.0dfsg-1) UNRELEASED; urgency=low

  * New upstream release.
    * Does not include standalone manuals any more, dropped tulip-doc package,
      updated manpage to point to official website for docs.
    * libtulip renamed to libtulip-core, libtulip-qt4 to libtulip-gui.
    * New thirdparty libs: qhull, qxt, quazip, yajl; update copyright file for
      them.
    * thirdparty libs all suffixed -tulip4.3.0
    * Does not include desktop file any more, adding it back with associated
      pixmap.
    * libtulip-dev now ships qtcreator templates.
    * no more contents for tulip-doc or tulip-help, drop packages and build-deps
      on docbook-xsl toolchain.
    * now requires libqtwebkit-dev.
  * Re-add versions to thirdparty libraries we ship, why on earth did upstream
    revert that !?
  * Fixed build system for the case of disabled python support.
  * Add (dummy) missing SOVERSION to thirdparty libs.
  * Updated debian/watch to tolerate underscores in filename.
  * Fixed to suggest cmake instead of automaken (has been wrong since 3.6).
  * Add tulip-dbg package.
  * Refresh main package description using upstream website headline.

 -- Yann Dirson <dirson@debian.org>  Fri, 27 Sep 2013 01:17:16 +0200

=== debian/control ===
Source: tulip
Section: graphics
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>= 9), cmake, libqt4-dev, qt4-dev-tools, freeglut3-dev, docbook-to-man, libgl1-mesa-dev | libgl-dev, dh-buildinfo, libfreetype6-dev, libxml2-dev, libgle3-dev, libxml2-utils, graphviz, libjpeg-dev, libpng-dev, libftgl-dev, libglew-dev, libqt4-opengl-dev, libqtwebkit-dev, binutils-dev [any-i386 any-amd64], python-sip-dev
Homepage: http://tulip-software.org/
Standards-Version: 3.9.3
Vcs-git: git://git.debian.org/git/collab-maint/tulip.git
Vcs-browser: http://git.debian.org/?p=collab-maint/tulip.git;a=summary

Package: tulip
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-dejavu-core
Description: System dedicated to the visualization of huge data sets as graphs
 Tulip is an information visualization framework dedicated to the
 analysis and visualization of relational data.  It aims to provide
 the developer with a complete library, supporting the design of
 interactive information visualization applications for relational
 data that can be tailored to the problems he or she is addressing.
 .
 It includes the following features:
 .
  * 3D visualizations
  * 3D modifications
  * Plug-in support for easy evolution
  * Building of clusters and navigation into them
  * Automatic drawing of graphs
  * Automatic clustering of graphs
  * Automatic selection of elements
  * Automatic metric coloration of graphs

Package: tulip-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - debug symbols
 Debug symbols for tulip, a system dedicated to the visualization of
 huge graphs, and its various libraries.

Package: libtulip-dev
Section: libdevel
Architecture: any
Depends: tulip (= ${binary:Version}), libc6-dev, ${misc:Depends}
Conflicts: libtulip-dev
Replaces: tulip (<= 2), libtulip-ogl-dev, libtulip-qt4-dev
Suggests: cmake
Enhances: qtcreator
Description: Tulip graph library - core development files
 Headers and static libraries for tulip, a system dedicated to the
 visualization of huge graphs.  Also include QtCreator templates.

Package: libtulip-core-4.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - core runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-ogl-4.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OpenGL runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the OpenGL rendering capabilities of the engine.

Package: libtulip-gui-4.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - Qt/OpenGL GUI runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Qt/OpenGL GUI support.

Package: libtulip-python-4.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libtulip-python
Conflicts: libtulip-python
Description: Tulip graph library - Qt/OpenGL GUI runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Qt/OpenGL GUI support.

Package: libtulip-ogdf-4.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OGDF runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Open Graph Drawing Framework support.

Package: libogdf-tulip4.4.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Open Graph Drawing Framework shared library, built for Tulip
 This is the Open Graph Drawing Framework library, built as a shared
 lib as required by Tulip.

Package: libgzstream-tulip4.4.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gzstream shared library, built for Tulip
 C++ iostream classes wrapping the zlib compression library, built as
 a shared lib as required by Tulip.

Package: libquazip-tulip4.4.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: quazip shared library, built for Tulip
 Runtime for the quazip C++ wrapper for ZIP/UNZIP, built as a
 shared lib as required by Tulip.

Package: libqxt-tulip4.4.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: qxt shared library, built for Tulip
 Runtime for a subset of Qxt, extensions to Qt core classes, built as
 a shared lib as required by Tulip.

Package: libyajl-tulip4.4.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: yajl shared library, built for Tulip
 Runtime for yajl, Yet Another JSON Library, built as a shared lib as
 required by Tulip.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH:BOOL=YES -DUBUNTU_PPA_BUILD=ON -DBUILD_DOC=OFF

override_dh_auto_build-arch:
	dh_auto_build --parallel
	docbook-to-man debian/tulip.sgml > debian/tulip.1

override_dh_auto_install-arch:
	dh_auto_install
	install -D -m644 debian/tulip.1 debian/tmp/usr/share/man/man1/tulip.1
	install -D -m644 debian/tulip.desktop debian/tmp/usr/share/applications/tulip.desktop
	install -D -m644 debian/TulipIcon.png debian/tmp/usr/share/pixmaps/TulipIcon.png
 #	cd debian/tmp/usr/share/doc && mv tulip-python libtulip-python-4.4
 # apply README instructions: install qtcreator templates in the correct place
	mkdir -p debian/tmp/usr/share/qtcreator/templates
	mv debian/tmp/usr/share/tulip/wizards/* debian/tmp/usr/share/qtcreator/templates/
	rmdir debian/tmp/usr/share/tulip/wizards
	rm debian/tmp/usr/share/qtcreator/templates/README.txt

override_dh_install:
	dh_install --fail-missing

override_dh_strip:
	dh_strip --dbg-package tulip-dbg

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/tulip.1
	rm -rf docs/doxygen/xml
